		.include "tn13def.inc"
		.DSEG		;  

.equ tm = 250 ;   

		.CSEG
		.org 0                 ;    
		rjmp reset          ;    reset
		.org 1
		reti ;Interr
		.org 2
		reti ;Pin Change Interrupt0
		.org 3
		rjmp timer0_ovf 
		.org 4
		reti ;EEPROM write complete
		.org 5
		reti ;Analog Comparator Interrupt
		.org 6
		rjmp timerA;Timer_Counter0A; Compare Match A
		.org 7
		reti ;Timer_Counter0B; Compare Match B
		.org 8
		reti ;Watchdog Timeout
		.org 9
		reti ;conversion;ADC Conversion Complete Handle 
reset:	

		wdr; Reset Watchdog Timer
		ldi r16,24
		out WDTCR, r16;
		ldi r16,12 
		out WDTCR, r16;
		LDI	ZL,Low(SRAM_START)	;     
		LDI	ZH,High(SRAM_START)
		CLR	R16			;  R16
Flush:	ST 	Z+,R16			;  0   
		CPI	ZH,High(RAMEND+1)	;   ?
		BRNE	Flush			; ?  !
		CPI	ZL,Low(RAMEND+1)	;     ?
		BRNE	Flush
		CLR	ZL			;  
		CLR	ZH
		LDI	ZL, 30		;    	
		CLR	ZH		;      
		DEC	ZL		;  
		ST	Z, ZH		;    0
		BRNE	PC-2		;      		
		ldi r16, RAMEND ;   r16    
		out SPL, r16


		sbi DDRB, 2
		ldi r16,tm
		out OCR0A,r16
		ldi r16,(1<<CS02)|(1<<CS00);   r16    CS01
		out TCCR0B,r16 ;     0  256
		ldi r16,6
		out TIMSK0, r16;

main:
		sei
		wdr;Reset Watchdog Timer

		sbrc r22,0  ;    r22.0  
		rjmp main


		sbr r22,1 ;    r22,0
		sbi PORTB,4 ;   i/o
		sbi DDRB, 4
		cbi DDRB, 4
		cbi PORTB,4   ;    i/o
		rjmp main


timer0_ovf:
		push r16   ;  r16  
		in r16, sreg
		push r16   ;  r16  

		cbr r22,1 ;    r22,0
	
		pop  r16     ;  r16
		out sreg, r16
		pop  r16     ;  r16
		reti

timerA:

		push r16   ;  r16  
		in r16, sreg
		push r16   ;  r16  

		sbis PINB, 4   ;       4   B
		sbi PORTB,2   ;    i/o
		sbic PINB, 4   ;       4   B
		cbi PORTB,2   ;    i/o

		pop  r16     ;  r16
		out sreg, r16
		pop  r16     ;  r16

		reti


